unit T10Unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CPort, StdCtrls, Gauges, ExtCtrls;

type
  TForm1 = class(TForm)
    ComPort1: TComPort;
    Button_Exit: TButton;
    Button_Connect: TButton;
    Edit1: TEdit;
    Button_GetData: TButton;
    Timer_Init: TTimer;
    Button_Stop: TButton;
    Button_Check: TButton;
    RadioButton1: TRadioButton;
    Edit2: TEdit;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    procedure Timer_InitStart(Sender: TObject);
    procedure Timer_InitCheck(Sender: TObject);
    procedure Timer_InitShow(Sender: TObject);
    procedure ComPortRxChar(Sender: TObject; Count: Integer);
    procedure Button_ExitClick(Sender: TObject);
    procedure Button_ConnectClick(Sender: TObject);
    procedure Button_GetDataClick(Sender: TObject);
    procedure Button_CheckClick(Sender: TObject);
    procedure Button_StopClick(Sender: TObject);
    procedure Timer_Save(Sender: TObject);
    procedure Edit2_OnChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Buffer: String;
  Data : array[1..65536,1..2] of byte;
  Sensors : byte;

implementation

{$R *.dfm}
procedure TForm1.Timer_InitStart(Sender: TObject);
var cp : TextFile;
    scp : string[7];
begin
  Timer_Init.Enabled := false;
  AssignFile(cp,'ComPort.txt');
  Reset(cp);
  ReadLn(cp,scp);
  CloseFile(cp);
  ComPort1.Port := scp;
  ComPort1.BaudRate := br9600;
  ComPort1.DataBits := dbEight;
  ComPort1.StopBits := sbOneStopBit;
  ComPort1.Parity.Check := False;
  ComPort1.FlowControl.FlowControl := fcNone;
  ComPort1.Timeouts.ReadInterval := -1;
  ComPort1.Open;
  Button_Connect.Enabled := True;
  Button_GetData.Enabled := True;
  Button_Exit.Enabled := True;
  Button_Stop.Enabled := True;
  Button_Check.Enabled := True;
  RadioButton1.Enabled := True;
  CheckBox1.Enabled := True;
  Sensors := 10;
  Edit2.Text := IntToStr(Sensors);
  Edit2.Enabled := True;
  RadioButton1.Checked := False;
  Edit1.Text := Edit1.Text + 'OK.';
  if ComPort1.Connected = True then CheckBox1.Checked := True;
  Update;
end;

function CleanBuffer( Buffer : string ):string;
var buf : string;
    Len, i : Word;
begin
  Len := Length(Buffer);
  for i:=1 to Len do
  begin
    if (Buffer[i] <> #13) and (Buffer[i] <> #10) then buf := buf + Buffer[i];
    if Buffer[i] = #13 then  buf := buf + ' ';
  end;
  CleanBuffer := buf;
end;

procedure TForm1.Timer_InitCheck(Sender: TObject);
begin
  if RadioButton1.Checked = False then
  begin
    Timer_Init.Enabled := false;
    Edit1.Text := Edit1.Text + 'OK';
    Timer_Init.OnTimer := Timer_Save;
    Timer_Init.Interval := 1000;
    Timer_Init.Enabled := True;
  end
  else
    RadioButton1.Checked := False;
  Update;
end;

procedure TForm1.Timer_InitShow(Sender: TObject);
begin
  Timer_Init.Enabled := false;
  Edit1.Text := Edit1.Text + CleanBuffer(Buffer);
  if RadioButton1.Checked = False then
    Edit1.Text := Edit1.Text + 'Bd!!!'
  else
  begin
    if Timer_Init.Tag = 1 then
    begin
      Timer_Init.Tag := 0;
      Edit1.Text := Edit1.Text + 'sekund od ostatniego pomiaru.'
    end;
  end;
  RadioButton1.Checked := False;
  Update;
end;

procedure TForm1.ComPortRxChar(Sender: TObject; Count: Integer);
var
  S: String;
begin
  ComPort1.ReadStr(S, Count);
  Buffer := Buffer + S;
  RadioButton1.Checked := True;
  Update;
end;

procedure TForm1.Button_ExitClick(Sender: TObject);
begin
  if ComPort1.Connected = True then ComPort1.Close;
  Application.Terminate;
end;

procedure TForm1.Button_ConnectClick(Sender: TObject);
var
  Present: TDateTime;
  Year, Month, Day, Hour, Min, Sec, MSec: Word;
  Dat1, Dat2, Tim1, Tim2 : string[1];
begin
  Present:= Now;
  Edit1.Text := 'Inicjalizacja systemu pomiarowego (';
  DecodeDate(Present, Year, Month, Day);
  Edit1.Text := Edit1.Text + IntToStr(Day) + '.' + IntToStr(Month) + '.' + IntToStr(Year) + ' ';
  DecodeTime(Present, Hour, Min, Sec, MSec);
  Edit1.Text := Edit1.Text + IntToStr(Hour) + ':' + IntToStr(Min) + '): ';
  Update;
  Dat1 := Chr(Day+47);
  Dat2 := Chr(Month+47);
  Tim1 := Chr(Hour+47);
  Tim2 := Chr(Min+47);
  Buffer := '';
  ComPort1.WriteStr('I');
  ComPort1.WriteStr(Dat1);
  ComPort1.WriteStr(Dat2);
  ComPort1.WriteStr(Tim1);
  Timer_Init.Interval := 2000;
  Timer_Init.OnTimer := Timer_InitShow;
  Timer_Init.Enabled := True;
  ComPort1.WriteStr(Tim2);
end;

procedure TForm1.Button_GetDataClick(Sender: TObject);
begin
  Buffer := '';
  Edit1.Text := 'Pobieranie danych... ';
  Update;
  Timer_Init.Interval := 3000;
  Timer_Init.OnTimer := Timer_InitCheck;
  Timer_Init.Enabled := True;
  ComPort1.WriteStr('G');
end;

procedure TForm1.Button_CheckClick(Sender: TObject);
begin
  Buffer := '';
  Edit1.Text := 'Aktywnosc systemu: ';
  Update;
  Timer_Init.Interval := 2000;
  Timer_Init.OnTimer := Timer_InitShow;
  Timer_Init.Tag := 1;
  Timer_Init.Enabled := True;
  ComPort1.WriteStr('C');
end;

procedure TForm1.Button_StopClick(Sender: TObject);
begin
  Buffer := '';
  Edit1.Text := 'Zatrzymanie pomiarw: ';
  Update;
  Timer_Init.Interval := 2000;
  Timer_Init.OnTimer := Timer_InitShow;
  Timer_Init.Enabled := True;
  ComPort1.WriteStr('s');
end;

function DaysInMonth( Month : byte):byte;
var Days : byte;
begin
  case Month of
  1,3,5,7,8,10,12: Days := 31;
  2: Days := 28;
  4,6,9,11: Days := 30;
  else
   Days := 0;
  end;
  DaysInMonth := Days;
end;

procedure DT( dMinute : LongInt; var Day : byte; var Month : byte; var Hour : byte; var Minute : byte );
begin
  if dMinute < 60 then
  begin
    Minute := Minute + dMinute;
    if Minute > 59 then
    begin
      Minute := Minute - 60;
      Hour := Hour + 1;
      If Hour > 23 then
      begin
        Hour := Hour - 24;
        Day :=  Day + 1;
        if Day > DaysInMonth( Month ) then
        begin
          Day := 1;
          Month := Month + 1;
          if Month > 12 then Month := 1;
        end;
      end;
    end;
  end
  else
  begin
    Minute := Minute + dMinute - 60;
    Hour := Hour + 1;
    If Hour > 23 then
    begin
      Hour := Hour - 24;
      Day :=  Day + 1;
      if Day > DaysInMonth( Month ) then
      begin
        Day := 1;
        Month := Month + 1;
        if Month > 12 then Month := 1;
      end;
    end;
    if Minute > 59 then
    begin
      Minute := Minute - 60;
      Hour := Hour + 1;
      If Hour > 23 then
      begin
        Hour := Hour - 24;
        Day :=  Day + 1;
        if Day > DaysInMonth( Month ) then
        begin
          Day := 1;
          Month := Month + 1;
          if Month > 12 then Month := 1;
        end;
      end;
    end;
  end;
end;

procedure TForm1.Timer_Save(Sender: TObject);
var   ctr, output : TextFile;
      header : string[10];
      n, i : integer;
      DataH, DataL, sens: byte;
      td, znak : double;
      tw : word;
      Dat1, Dat2, Tim1, Tim2 : byte;
      Day, Month, Hour, Minute : byte;
      Days, Second : Word;
      Present: TDateTime;
      DTstart, DTstop, DTd : LongInt;
      Year1, Month1, Day1, Hour1, Min1, Sec1, MSec1: Word;
begin
  Timer_Init.Enabled := False;
  AssignFile(ctr,'data.txt');
  Rewrite(ctr);
  Write(ctr,Buffer);
  CloseFile(ctr);
  Reset(ctr);
  ReadLn(ctr,header);
  if header <> 'DATA' then
  begin
    CloseFile(ctr);
    Edit1.Text := 'Nieprawidowe dane! Sprbuj jeszcze raz...';
    Update;
  end
  else
  begin
    Edit1.Text := 'Trwa konwersja...';
    Update;
    //Czas startu odczytw
    ReadLn(ctr,Dat1);
    Day :=  Dat1 - 47;
    ReadLn(ctr,Dat2);
    Month :=  Dat2 - 47;
    ReadLn(ctr,Tim1);
    Hour :=  Tim1 - 47;
    ReadLn(ctr,Tim2);
    Minute :=  Tim2 - 47;
    //kiedy byl ostatni pomiar
    ReadLn(ctr,Second);
    //Liczba odczytw
    ReadLn(ctr,n);
    n := n div 2;
    //interwa odczytw
    Days := 0;
    for i:=1 to Month do Days := Days + DaysInMonth(i);
    DTstart := Minute * 60 + Hour * 3600 + Day * 24 * 3600 + Days * 24 * 3600;
    //Aktualny czas
    Present:= Now;
    DecodeDate(Present, Year1, Month1, Day1);
    DecodeTime(Present, Hour1, Min1, Sec1, MSec1);
    Days := 0;
    if Month1 < Month then Days := 365;
    for i:=1 to Month1 do Days := Days + DaysInMonth(i);
    DTstop := Sec1 + Min1 * 60 + Hour1 * 3600 + Day1 * 24 * 3600 + Days * 24 * 3600 - Second;
    if n > Sensors then
      DTd := (DTstop - DTstart) div (( n div Sensors ) - 1)
    else
      DTd := 0;  
    DTd := DTd div 60;
    //Konwersja
    AssignFile(output,'temperatury.txt');
    Rewrite(output);
    Write(output,'Data':7,'Czas':7);
    for i:=0 to (Sensors-1) do Write(output,'T':6,i:1);
    WriteLn(output);
    sens := 0;
    for i:=1 to n do
    begin
      sens := sens + 1;
      if sens > Sensors then
      begin
        sens := 1;
        WriteLn(output);
      end;
      //zapis daty i czasu linijki odczytw
      if sens = 1 then
      begin
        Write(output,'  ');
        if Day < 10 then Write(output,'0');
        Write(output,Day,'/');
        if Month < 10 then Write(output,'0');
        Write(output,Month);
        Write(output,'  ');
        if Hour < 10 then Write(output,'0');
        Write(output,Hour,':');
        if Minute < 10 then Write(output,'0');
        Write(output,Minute);
        DT( DTd, Day, Month, Hour, Minute );
      end;
      ReadLn(ctr,DataL);
      ReadLn(ctr,DataH);
      tw := DataH * 256 + DataL;
      znak := 1.0;
      if tw > 16000 then
      begin
        tw := tw xor 65535;
        tw := tw + 1;
        znak := -1.0;
      end;
      td := znak * tw * 0.0625;
      Write(output, td:7:2);
    end;
    WriteLn(output);
    CloseFile(ctr);
    CloseFile(output);
    Edit1.Text := 'Gotowe! Wyniki zapisano w pliku TEMPERATURY.TXT';
    Update;
  end;
end;

procedure TForm1.Edit2_OnChange(Sender: TObject);
begin
  Sensors := StrToInt(Edit2.Text);
  Update;
end;

end.
